<?php
	error_reporting(0);		// Esto es importante para que no muestre los warning en la comunicación

  	class io {
		public $socket,$gprog,$ip,$port,$bns,$bnsport,$bnssock,$error,$time,$sesionnt,$try,$bnsiplist;
		public function __construct(){
			include("php/config.php");
			$this->confi    = $Confi;
			$this->mens     = 0;
			$this->error 	= "";
			$this->sesionnt = "";
			$this->contenv  = 0; 
		}

		public function leer() {
			$cbuf 	 = "";
			$tempbuf = "";
			$data    = [];
			$try     = 0;

			while (!feof($this->socket)) {
				$fin  = true;
				$buf  = "";
				$abuf = "";
				$pos  = -1;
				
		        $abuf = fread($this->socket, 8192);

				$buf=$tempbuf.$abuf;  

				if(substr($buf,0,1)=="C" or substr($buf,0,1)=="F"){
					$tempbuf=$buf;
					$tempa=[];
					$ltry=0;

					do{
						$ltry=$ltry+1;
						if($ltry>1000){
							die("Error de conexión 38");
						}
						if(substr($tempbuf,0,1)=="C" or substr($tempbuf,0,1)=="F"){
							$lastbuf=$tempbuf;
							$clen=substr($tempbuf,1,5);
							if((strlen($tempbuf)-(int)$clen)<0){
								$fin=false;
								break;
							}
							$pbuf=utf8_encode(substr($tempbuf,16,(int)$clen-16));
							$cbuf .= $pbuf;
							$casos=substr($pbuf,0,4);
							switch ($casos) {
								case 'RDAT':
									$rlen=strlen($pbuf);
									$nret=substr($pbuf,5);
									$dline=explode("\r\r",$nret);
									array_push($data, $dline);
									break;
								case 'REND':
									$cbuf=$data;
									break;
								default:
									break;
							}
							$tempbuf=substr($tempbuf,$clen);
						}
					}while(strlen($tempbuf)>16 and (substr($tempbuf,0,1)=="C" or substr($tempbuf,0,1)=="F")); 
				}
				else{
					return $buf." ";
				}

				if(substr($lastbuf,0,1)=="F"&&$fin){
					if(gettype($cbuf)=="array"){
						return $cbuf;
					}
					else{
						return $cbuf;
					}
				}
			}
		}

		/*** Función para la conexión inicial "abrimos worker" ****/
		public function conectar(){
			$this->socket = fsockopen($this->ip, $this->port, $errNum, $errStr, 20);
			if (!empty($errNum) || !empty($errStr)) {          
		    	return false;
		    }
		    return true;
		}

		public function preconectar(){		
			$fp = fopen("http://www.clienteair.com/ipbns.php", "r");
			if(!$fp){
				/* Se añade la ip y puertos nuevos */
				$bnsipport='[[["213.96.211.229","443"],["213.96.211.229","17694"],["213.96.211.229","17696"],["213.96.211.229","17698"],["213.96.211.229","17693"]],[["213.96.211.229","443"],["80.38.176.176","17694"],["80.38.176.176","17696"],["80.38.176.176","17698"],["80.38.176.176","17693"]]]';
				$this->bnsiplist=json_decode($bnsipport,true);
				$this->try=0;
				shuffle($this->bnsiplist);
				/*****/
			}
			else{
				$bnsipport=fread($fp,5000);
				$this->bnsiplist=json_decode($bnsipport,true);
				$this->try=0;
				shuffle($this->bnsiplist);
			}

			$this->BNSConnect();
		}
		
		public function BNSConnect(){
			if($this->try==count($this->bnsiplist)){
				die("No se pudo conectar");
			}

			$ip   = $this->bnsiplist[$this->try][0][0];
			$port = $this->bnsiplist[$this->try][0][1];
			$this->try = $this->try+1;

			$this->bnssock = fsockopen($ip, $port, $errNum, $errStr, 20);
			if (!empty($errNum) || !empty($errStr)) {   
		    	fclose($this->bnssock);
		    	$this->BNSConnect();
		    }

			$tosend="START ".$this->bns;
			$msg="C".$this->zeroFill(strlen($tosend)+16,5)."/".$this->zeroFill(strlen($tosend)+16,9).$tosend;

			$_lcvbytes = fwrite($this->bnssock, $msg, strlen($msg));
			if($_lcvbytes===false || $_lcvbytes===0){
				echo "Error al enviar";
				return;
			}

			$abuf = fread($this->bnssock, 8192);
			
			$Res=substr($abuf,16);
			if(substr($Res, 0,2)==="IP"){
				$gpos=strpos($Res,"-");
				$finalip=trim(substr($Res,3,$gpos-3));
				$finalport=substr($Res,$gpos+1);				
				$this->ip=$finalip;
				$this->port=$finalport;
			}
			else if(substr($Res, 0,2)==="NT"){
				$fp = fopen("http://www.clienteair.com/bs.php", "r");
				if(!$fp){
					$finalip="212.170.195.50";
					$finalport=9888;	
				}
				else{
					$bsipport=fread($fp,50);
					$finalip=substr($bsipport, 0,strpos($bsipport, ":"));
					$finalport=(int)substr($bsipport, strpos($bsipport, ":")+1);
				}
				$this->sesionnt=substr($Res,3);
				$this->ip=$finalip;
				$this->port=$finalport;
			}
			else{
				fclose($this->bnssock);
		    	$this->BNSConnect();
			}
			fclose($this->bnssock);
		}

		public function cerrar(){
			fclose($this->socket);
		}

		public function enviar($msg,$sockenv){
			$_lcvbytes = fwrite($sockenv, $msg, strlen($msg));

			if($_lcvbytes===false || $_lcvbytes===0){
				if($this->contenv===4){
					return false;
				}
				else{
					$this->contenv = $this->contenv + 1;	// Contador
				}

				$this->cerrar();	// Como fallo el write, cerramos socket y volvemos a conectar
				
				$this->socket = fsockopen($this->ip, $this->port, $errNum, $errStr, 20);
				if (!empty($errNum) || !empty($errStr)){
			    	return false;
			    }

				$this->enviar($msg,$this->socket);	// Una vez conectados volvemos a intentar enviar
			}
		}

		public function airsegur($session){
			/***/
			if(!empty($this->sesionnt)){
				$this->enviar("PHP ".$this->sesionnt.$session,$this->socket);
				$this->leer();
			}
			/***/

			$pag 	 = $this->zeroFill(strlen($_SERVER['PHP_SELF']),2).$_SERVER['PHP_SELF'];
			$browser = $this->getBrowser();
			$nav 	 = $browser['name']." ".$browser['version'];
			$nav 	 = $this->zeroFill(strlen($nav),2).$nav;
			$conf 	 = $this->zeroFill(strlen($this->confi),2).$this->confi;
			$cline 	 = "#SL#".$pag.$nav.$conf;
			$cline 	 = $this->zeroFill(strlen($cline),4)."11".$cline.$session;
			
			$EnvOk = $this->enviar($cline,$this->socket);
			if($EnvOk===false){
				return $EnvOk;	// Si no podemos enviar retornamos false
			}

			$this->leer();		// Leemos lo que nos responde el #SL#

			return true;
		}

		// 16/07/2020 AOP - Se comenta la función genchain y se substituye por la nueva para poder enviar carritos grandes
		/*public function genchain($pre,$query,$session){
			$lcvLenConsulta = str_pad(strlen($query),4, "0",STR_PAD_LEFT);
			$EnvOk = true;

			$_lcvtry = 0;
			do{
				$lcvCadena=$pre.$lcvLenConsulta.$query.$session;
				if(strlen($lcvCadena)<=8192){
					$lcvlen = str_pad(strlen($lcvCadena),4, "0",STR_PAD_LEFT);
					$lcvCad = $lcvlen."11".$lcvCadena;
					$lcvCad = base64_encode($lcvCad);		// Codificamos los mensajes
					$EnvOk  = $this->enviar($lcvCad,$this->socket);
				}
				else{
					$lcvTemp=$lcvCadena;
					$lcvStart="1";
					$lcvEnd="0";
					do{
						if(strlen($lcvTemp)>8192){
							$lcvlen = 8192;
							$lcvCad = $lcvlen.$lcvStart.$lcvEnd.$lcvTemp;
							$lcvCad = base64_encode($lcvCad);		// Codificamos el mensaje a enviar
							$EnvOk  = $this->enviar($lcvCad,$this->socket);
						}
						else{
							$lcvEnd = "1";
							$lcvlen = str_pad(strlen($lcvTemp),4, "0",STR_PAD_LEFT);
							$lcvCad = $lcvlen.$lcvStart.$lcvEnd.$lcvTemp;
							$lcvCad = base64_encode($lcvCad);		// Codificamos el mensaje a enviar
							$EnvOk  = $this->enviar($lcvCad,$this->socket);
						}
						$lcvTemp=substr($lcvTemp, $lcvLen);
						$lcvStart="0";
					}while(strlen($lcvTemp)!=0);
				}

				if($EnvOk===false){
					return "QUIT";   		// Si no podemos enviar retornamos false
				}

				$ret = $this->leer();

				$_lcvtry = $_lcvtry+1;

				if($_lcvtry==5){
					break;
				}
			}while(empty($ret));

			return $ret;
		}*/

		// 16/07/2020 AOP - Se añade nueva función genchain y strX para enviar cadenas grandes
		public function genchain($pre,$query,$session){
			$lcvLenConsulta = $this->strX(strlen($query));
			$EnvOk = true;

			$_lcvtry = 0;
			do{
				$lcvCadena=$pre.$lcvLenConsulta.$query.$session;

				$lcvlen = $this->strX(strlen($lcvCadena));
				$lcvCad = $lcvlen."11".$lcvCadena;
				$lcvCad = base64_encode($lcvCad);

				$lcvLenEnc = $this->strX(strlen($lcvCad));
				$lcvCad = "BSL ".$lcvLenEnc." ".$lcvCad;
				$EnvOk  = $this->enviar($lcvCad,$this->socket);				

				if($EnvOk===false){
					return "QUIT";   		// Si no podemos enviar retornamos false
				}

				$ret = $this->leer();

				$_lcvtry = $_lcvtry+1;

				if($_lcvtry==5){
					break;
				}
			}while(empty($ret));
			return $ret;
		}

		// Función que convierte el numero en Byte y asi poder enviar longitudes mas grandes que "9999".
		function strX($lpnum){
			if($lpnum<=9999){
				return str_pad($lpnum,4,"0",STR_PAD_LEFT);
			}
			else{
				$lcvRetValue = "";
				for ($lcvf = 1; $lcvf <= 3; $lcvf++){
				    $lcvVal = fmod($lpnum,256);
				    $lcvRetValue = chr($lcvVal).$lcvRetValue;
				    $lpnum = intval($lpnum/256);
				}
				$lcvRetValue="X".$lcvRetValue;
				return $lcvRetValue;
			}
		}
		/*******************/

		function zeroFill($number, $width){
			return str_pad(trim((string)$number),$width,"0",STR_PAD_LEFT);
		}

		function getBrowser() { 
			$u_agent = $_SERVER['HTTP_USER_AGENT']; 
			$bname = 'Unknown';
			$platform = 'Unknown';
			$version= "";
			//First get the platform?
			if (preg_match('/linux/i', $u_agent)) {
				$platform = 'linux';
			}
			elseif (preg_match('/macintosh|mac os x/i', $u_agent)) {
				$platform = 'mac';
			}
			elseif (preg_match('/windows|win32/i', $u_agent)) {
				$platform = 'windows';
			}
			// Next get the name of the useragent yes seperately and for good reason
			if(preg_match('/MSIE/i',$u_agent) && !preg_match('/Opera/i',$u_agent)) 
			{ 
				$bname = 'Internet Explorer'; 
				$ub = "MSIE"; 
			} 
			elseif(preg_match('/Firefox/i',$u_agent)) 
			{ 
				$bname = 'Mozilla Firefox'; 
				$ub = "Firefox"; 
			} 
			elseif(preg_match('/Opera/i',$u_agent)) 
			{ 
				$bname = 'Opera'; 
				$ub = "Opera"; 
			} 
			elseif(preg_match('/OPR/i',$u_agent)) 
			{ 
				$bname = 'Opera'; 
				$ub = "Opera"; 
			}  
			elseif(preg_match('/Chrome/i',$u_agent)) 
			{ 
				$bname = 'Google Chrome'; 
				$ub = "Chrome"; 
			} 
			elseif(preg_match('/Safari/i',$u_agent)) 
			{ 
				$bname = 'Apple Safari'; 
				$ub = "Safari"; 
			} 
			elseif(preg_match('/Netscape/i',$u_agent)) 
			{ 
				$bname = 'Netscape'; 
				$ub = "Netscape"; 
			} 

			// finally get the correct version number
			$known = array('Version', $ub, 'other');
			$pattern = '#(?<browser>' . join('|', $known) .')[/ ]+(?<version>[0-9.|a-zA-Z.]*)#';
			if (!preg_match_all($pattern, $u_agent, $matches)) {
				// we have no matching number just continue
			}
			// see how many we have
			$i = count($matches['browser']);
			if ($i != 1) {
				//we will have two since we are not using 'other' argument yet
				//see if version is before or after the name
				if (strripos($u_agent,"Version") < strripos($u_agent,$ub)){
					$version= $matches['version'][0];
				}
				else {
					$version= $matches['version'][1];
				}
			}
			else {
				$version= $matches['version'][0];
			}

			// check if we have a number
			if ($version==null || $version=="") {$version="?";}
			return array(
				'userAgent' => $u_agent,
				'name'		=> $bname,
				'version'   => $version,
				'platform'  => $platform,
				'pattern'   => $pattern
			);
		}
	}
?>